// Lights.cpp: implementation of the CLights class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Lights.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLights::CLights()
{

  m_OSVersionInfo.dwOSVersionInfoSize = sizeof( OSVERSIONINFO );
  VERIFY( GetVersionEx( &m_OSVersionInfo ));

}

CLights::~CLights()
{

}

void CLights::ToggleNumLock()
{
	if( m_OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
    {
    BYTE KeyboardState[ 256 ];
    VERIFY( GetKeyboardState( KeyboardState ));
    KeyboardState[ VK_NUMLOCK ] = KeyboardState[ VK_NUMLOCK ] ^ 1;
    VERIFY( SetKeyboardState( KeyboardState ));
    }
  else if( m_OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT )
    { 
    keybd_event( VK_NUMLOCK, 0x45, KEYEVENTF_EXTENDEDKEY | 0, 0 );
    keybd_event( VK_NUMLOCK, 0x45, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0 );
    }
  else
    ; // OS not supported


}



void CLights::ToggleScrollLock()
{
	if( m_OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
    {
    BYTE KeyboardState[ 256 ];
    VERIFY( GetKeyboardState( KeyboardState ));
    KeyboardState[ VK_SCROLL ] = KeyboardState[ VK_SCROLL ] ^ 1;
    VERIFY( SetKeyboardState( KeyboardState ));
    }
  else if( m_OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT )
    { 
    keybd_event( VK_SCROLL, 0x45, KEYEVENTF_EXTENDEDKEY | 0, 0 );
    keybd_event( VK_SCROLL, 0x45, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0 );
    }
  else
    ; // OS not supported

}

BOOL CLights::GetNumLockStatus()
{
	return (GetKeyState( VK_NUMLOCK ) & 0x0001);
}

BOOL CLights::GetScrollLockStatus()
{
	return (GetKeyState( VK_SCROLL ) & 0x0001);
}



BOOL CLights::EnableNumLock(BOOL bEnable)
{
	if(bEnable)
	{ //we're turning on

		if(GetNumLockStatus())
			return FALSE; //already turned on !
	
		ToggleNumLock();
		return TRUE;
	}
	else
	{ //we're turning off !
		if(GetNumLockStatus() == FALSE)
			return FALSE; //already turned on !
	
		ToggleNumLock();
		return TRUE;

	}
}

BOOL CLights::EnableScrollLock(BOOL bEnable)
{
	if(bEnable)
	{ //we're turning on

		if(GetScrollLockStatus())
			return FALSE; //already turned on !
	
		ToggleScrollLock();
		return TRUE;
	}
	else
	{ //we're turning off !
		if(GetScrollLockStatus() == FALSE)
			return FALSE; //already turned on !
	
		ToggleScrollLock();
		return TRUE;

	}
}

void CLights::ToggleCapsLock()
{
	if( m_OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
    {
    BYTE KeyboardState[ 256 ];
    VERIFY( GetKeyboardState( KeyboardState ));
    KeyboardState[ VK_CAPITAL ] = KeyboardState[ VK_CAPITAL ] ^ 1;
    VERIFY( SetKeyboardState( KeyboardState ));
    }
  else if( m_OSVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT )
    { 
    keybd_event( VK_CAPITAL, 0x45, KEYEVENTF_EXTENDEDKEY | 0, 0 );
    keybd_event( VK_CAPITAL, 0x45, KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP, 0 );
    }
  else
    ; // OS not supported
}

BOOL CLights::GetCapsLockStatus()
{
	return (GetKeyState( VK_CAPITAL ) & 0x0001);
}

BOOL CLights::EnableCapsLock(BOOL bEnable)
{
	if(bEnable)
	{ //we're turning on

		if(GetCapsLockStatus())
			return FALSE; //already turned on !
	
		ToggleCapsLock();
		return TRUE;
	}
	else
	{ //we're turning off !
		if(GetCapsLockStatus() == FALSE)
			return FALSE; //already turned on !
	
		ToggleCapsLock();
		return TRUE;

	}
}
